/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _KEPLERBUBBLE_H_
#define _KEPLERBUBBLE_H_

#include <vector>
 
#include "game.h"
#include "variousEntities/prism.h"
 

const float DIST_INIT_KB = 130.;

const float Y_PRISM = 34; //33.86751346 // ((3 + 1/3)*sqrt(3)/2 + 1/2)*diametre + un petit chouia 
 
const float Z_MAX = 90.;
const float Z_MIN = -5.; 


class KeplerBubble: public Game 
{
public:
	KeplerBubble();
	KeplerBubble(std::vector<int> _colors, int _nbPlayers);
	~KeplerBubble();

	void initGame();
	void reinitPosCamera();	
		
	void initDisplayEnvironments ();
	void createObjects ();
	void createLights ();
					
	void quit();
	
	void updateAnimations(double currentTime, double intervalTime);		
		
	int nextColor();

	//keyboard	
	bool keyboardEvent(SDLKey key, double timeInterval);

		
	//mouse event
	void mouseMotion(int xOld, int yOld, int xNew, int yNew, bool left, bool middle, bool right) ;
	void leftClick(int x, int y);
	void rightClick(int x, int y);
	void middleClick(int x, int y);			
	void mouseWheel(int w);
			
private:
	std::vector<int> colors;
	int nbPlayers;
	int currentColor;

	LightPointList lights;
	//KeplerPrism *prism;
};

#endif // _KEPLERBUBBLE_H_
