/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SHADER_H_
#define _SHADER_H_

#include <vector>
#include <string>
#include <iostream>
#include <sstream>

#include "glUtil.h"
#include "color.h"
#include "shaderLoader.h"
#include "shaderWriter.h"

class Shader
{
public:
	Shader();
	
	Shader(std::vector<std::string> vsFilenames, std::vector<std::string> vsGeneratedSources, std::string vsMainSourceFile,
		   std::vector<std::string> fsFilenames, std::vector<std::string> fsGeneratedSources, std::string fsMainSourceFile);
	
	Shader (std::vector<std::string> vsFiles, std::vector<std::string> fsFiles);
		
	~Shader();

	GLuint getId();
		
	
protected:
	GLuint id;   
		   		   
	/* load a shader program */		
	GLuint loadProgram(GLuint vertexShader, GLuint fragmentShader);
	GLuint loadProgram(std::vector<std::string> vsFilenames, std::vector<std::string> vsGeneratedSources, std::string vsMainSourceFile,
					   std::vector<std::string> fsFilenames, std::vector<std::string> fsGeneratedSources, std::string fsMainSourceFile);
	GLuint loadProgram(std::vector<std::string> vsFiles, std::vector<std::string> fsFiles);	
};
	
	
	
#endif // _SHADER_H_
