/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SKY_H_
#define _SKY_H_

#include <string>

#include "glUtil.h"
#include "imagePng.h"
#include "vector3.h"
#include "shaderManager.h"
#include "textureLayer.h"
#include "entity.h"

#include "../variousEntities/rectangle.h"
#include "../variousEntities/partialSphere.h"



class Sky
{
public:
	Sky(std::string skyTexFilename, std::string skyNightTexFilename);
	~Sky();
		
	void setSunDirection (Vector3 sunDirection);
	Vector3 getSunDirection (Vector3 sunDirection);
		
	void display();
		
protected:
	TextureLayer *skyTex;
	TextureLayer *skyNightTex;
	PartialSphereMesh *skyDome;

	Vector3 mSunDirection;
		
			
};



class SkyPlane
{
public:
	SkyPlane(std::string skyTexFilename, float dist, float height, bool alphaClouds);
	~SkyPlane();
		
	void display();

protected:
	Material *mpMaterial;
	RectangleMesh *mpPlane;
	float mHeight;
	
};
	

#endif // _SKY_H_
