/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
#include "textUtil.h"
#include "fileManager.h"
 
string getFilename(wchar_t c) {
	int unicodeVal = c;
	ostringstream oss;
	oss << fileMana->getFontsDir() << "/" << c << ".png";
	string filename = oss.str();

	return filename;
 }

 
 void getCharParam(wchar_t c, int & width, int & deltax, int & deltay) {
	switch(c) {
		case L' ':
			width = 15;
			deltax = 0;
			deltay = 0;
			break;

		case L'!':
			width = 9;
			deltax = 0;
			deltay = 0;
			break;			

		case L'\"':
			width = 14;
			deltax = -2;
			deltay = -16;
			break;			

		case L'#':
			width = 28;
			deltax = 0;
			deltay = 0;
			break;			

		case L'$':
			width = 21;
			deltax = 0;
			deltay = 5;
			break;				
			
		case L'-':
			width = 21;
			deltax = 0;
			deltay = -8;
			break;

			
		case L'0':
			width = 20;
			deltax = 0;
			deltay = 0;
			break;

		case L'1':
			width = 20;
			deltax = 0;
			deltay = 1;
			break;

		case L'2':
			width = 24;
			deltax = 0;
			deltay = 2;
			break;			

		case L'3':
			width = 22;
			deltax = 0;
			deltay = 2;
			break;			

		case L'4':
			width = 22;
			deltax = 0;
			deltay = 7;
			break;			

		case L'5':
			width = 23;
			deltax = 0;
			deltay = 0;
			break;

		case L'6':
			width = 19;
			deltax = 0;
			deltay = 0;
			break;			

		case L'7':
			width = 26;
			deltax = 0;
			deltay = 2;
			break;
			
		case L'8':
			width = 20;
			deltax = 0;
			deltay = 0;
			break;
			
		case L'9':
			width = 21;
			deltax = 2;
			deltay = 4;
			break;			
			
			
		case L'A':
			width = 33;
			deltax = 4;
			deltay = 8;
			break;

		case L'B':
			width = 32;
			deltax = 2;
			deltay = 0;
			break;			

		case L'C':
			width = 22;
			deltax = 2;
			deltay = 0;
			break;				
			
		case L'D':
			width = 27;
			deltax = 2;
			deltay = 3;
			break;	
			
		case L'E':
			width = 22;
			deltax = 2;
			deltay = 0;
			break;

		case L'F':
			width = 24;
			deltax = 2;
			deltay = 3;
			break;			
			
		case L'G':
			width = 22;
			deltax = 2;
			deltay = 13;
			break;			
			
		case L'H':
			width = 25;
			deltax = 2;
			deltay = 3;
			break;			

		case L'I':
			width = 12;
			deltax = 2;
			deltay = 0;
			break;	

		case L'J':
			width = 28;
			deltax = 5;
			deltay = 14;
			break;			

		case L'K':
			width = 29;
			deltax = 2;
			deltay = 3;
			break;				

		case L'L':
			width = 25;
			deltax = 2;
			deltay = 0;
			break;

		case L'M':
			width = 35;
			deltax = 4;
			deltay = 3;
			break;			

		case L'N':
			width = 35;
			deltax = 5;
			deltay = 0;
			break;				
			
		case L'O':
			width = 24;
			deltax = 0;
			deltay = 0;
			break;			
			
		case L'P':
			width = 25;
			deltax = 2;
			deltay = 0;
			break;			

		case L'Q':
			width = 25;
			deltax = 2;
			deltay = 5;
			break;			
			
		case L'R':
			width = 31;
			deltax = 2;
			deltay = -1;
			break;			
			
		case L'S':
			width = 24;
			deltax = 0;
			deltay = 0;
			break;
			
		case L'T':
			width = 32;
			deltax = 2;
			deltay = 0;
			break;

		case L'U':
			width = 30;
			deltax = 2;
			deltay = 0;
			break;			

		case L'V':
			width = 28;
			deltax = 2;
			deltay = 0;
			break;				

		case L'W':
			width = 38;
			deltax = 2;
			deltay = 0;
			break;				

		case L'X':
			width = 31;
			deltax = 2;
			deltay = 0;
			break;			
			
		case L'Y':
			width = 35;
			deltax = 2;
			deltay = 8;
			break;	

		case L'Z':
			width = 30;
			deltax = 2;
			deltay = 0;
			break;				
			
			
		case L'a':
			width = 23;
			deltax = 0;
			deltay = 0;
			break;
			
		case L'b':
			width = 24;
			deltax = 2;
			deltay = 0;
			break;

		case L'c':
			width = 17;
			deltax = 1;
			deltay = 0;
			break;

		case L'd':
			width = 23;
			deltax = 1;
			deltay = 0;
			break;

		case L'e':
			width = 17;
			deltax = 1;
			deltay = 0;
			break;

		case L'f':
			width = 27;
			deltax = 9;
			deltay = 14;
			break;			

		case L'g':
			width = 20;
			deltax = 2;
			deltay = 12;
			break;

		case L'h':
			width = 21;
			deltax = 1;
			deltay = 0;
			break;			

		case L'i':
			width = 12;
			deltax = 1;
			deltay = 0;
			break;			

		case L'j':
			width = 18;
			deltax = 7;
			deltay = 12;
			break;			

		case L'k':
			width = 21;
			deltax = 2;
			deltay = 2;
			break;	

		case L'l':
			width = 14;
			deltax = 1;
			deltay = 0;
			break;			

		case L'm':
			width = 33;
			deltax = 2;
			deltay = 0;
			break;			

		case L'n':
			width = 21;
			deltax = 2;
			deltay = 0;
			break;

		case L'o':
			width = 17;
			deltax = 1;
			deltay = 0;
			break;			

		case L'p':
			width = 25;
			deltax = 2;
			deltay = 13;
			break;			

		case L'q':
			width = 19;
			deltax = 0;
			deltay = 16;
			break;

		case L'r':
			width = 19;
			deltax = 0;
			deltay = 0;
			break;			

		case L's':
			width = 19;
			deltax = 0;
			deltay = 0;
			break;				

		case L't':
			width = 15;
			deltax = 0;
			deltay = 0;
			break;			

		case L'u':
			width = 20;
			deltax = -1;
			deltay = 0;
			break;

		case L'v':
			width = 20;
			deltax = -2;
			deltay = 0;
			break;			

		case L'w':
			width = 32;
			deltax = -2;
			deltay = 0;
			break;			

		case L'x':
			width = 21;
			deltax = 0;
			deltay = 0;
			break;				

		case L'y':
			width = 27;
			deltax = 0;
			deltay = 17;
			break;	

		case L'z':
			width = 21;
			deltax = 0;
			deltay = 0;
			break;			
			
			
			
			
		case L'¡': //161, para los españoles ;)
			width = 9;
			deltax = 0;
			deltay = 0;
			break;			
						
			
			
			
		default : 	
			width = 15;
			deltax = 0;
			deltay = 0;
			break;
	}
 }
